/* Actions */
import {
    INIT_PAYMENTS_JOURNALS,
    SELECT_PAYMENTS_JOURNALS,
    ADD_PAYMENTS_MOVE_LINES,
    REMOVE_PAYMENTS_MOVE_LINES,
    CHANGE_INITIAL_PAID,
    RESET_SUPPLIER_PAYMENTS,
    RESET_SELECTED_JOURNAL_PAYMENTS,
    SELECT_PAYMENTS_PURCHASES_BANK,
    SELECT_PAYMENTS_PURCHASES_BANK_TYPE,
    CHANGE_PAYMENTS_PURCHASES_BANK_REF,
    CHANGE_PAYMENTS_PURCHASES_BANK_DATE_MATURITY,
    CHANGE_PAYMENTS_PURCHASES_BANK_NUMBER_CTA,
    CHANGE_PAYMENTS_PURCHASES_BANK_NAME_HOLDER,
    RESET_SUPPLIER_PAYMENTS_BANK
} from '@/constants/actionTypes'
/* Mutations */
import {
    SET_PAYMENTS_JOURNALS,
    SELECTED_PAYMENTS_JOURNALS,
    CALCULATE_PAYMENTS_TOTAL,
    CALCULATE_CURRENCY_AMOUNT,
    SET_ADD_PAYMENTS_MOVE_LINES,
    SET_REMOVE_PAYMENTS_MOVE_LINES,
    SET_PAID_TOTAL,
    SET_PAYMENTS_CURRENCY_JOURNAL,
    SELECTED_PAYMENTS_PURCHASES_BANK,
    SELECTED_PAYMENTS_PURCHASES_BANK_TYPE,
    SET_PAYMENTS_PURCHASES_BANK_REF,
    SET_PAYMENTS_PURCHASES_BANK_DATE_MATURITY,
    SET_PAYMENTS_PURCHASES_BANK_NUMBER_CTA,
    SET_PAYMENTS_PURCHASES_BANK_NAME_HOLDER
} from '@/constants/mutationTypes'

const initialState = {
    paymentsJournals: [],
    paymentsSelectedJournal: null,
    paymentsMoveLines: [],
    paymentsCurrencyAmount: [],
    paymentsCurrencyJournal: null,
    paymentsTotal: 0,
    paidTotal: 0,
    paymentsReturned: 0,
    selectedPaymentsBank: null,
    selectedPaymentsBankType: null,
    paymentsBankRef: '',
    paymentsBankDateMaturity: '',
    paymentsBankNumberCta: '',
    paymentsBankNameHolder: ''
}

const state = {
    paymentsJournals: initialState.paymentsJournals,
    paymentsSelectedJournal: initialState.paymentsSelectedJournal,
    paymentsMoveLines: initialState.paymentsMoveLines,
    paymentsCurrencyAmount : initialState.paymentsCurrencyAmount,
    paymentsCurrencyJournal: initialState.paymentsCurrencyJournal,
    paymentsTotal: initialState.paymentsTotal,
    paidTotal: initialState.paidTotal,
    paymentsReturned: initialState.paymentsReturned,
    selectedPaymentsBank: initialState.selectedPaymentsBank,
    selectedPaymentsBankType: initialState.selectedPaymentsBankType,
    paymentsBankRef: initialState.paymentsBankRef,
    paymentsBankDateMaturity: initialState.paymentsBankDateMaturity,
    paymentsBankNumberCta: initialState.paymentsBankNumberCta,
    paymentsBankNameHolder: initialState.paymentsBankNameHolder
}

const getters = {
    /**
     * [paymentsJournals description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    paymentsJournals ( state ) {
            return state.paymentsJournals
    },
    /**
     * [paymentsSelectedJournal description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    paymentsSelectedJournal ( state ) {
        return state.paymentsSelectedJournal
    },
    /**
     * [paymentsMoveLines description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    paymentsMoveLines ( state ) {
        return state.paymentsMoveLines
    },
    /**
     * [paymentsCurrencyAmount description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    paymentsCurrencyAmount ( state ) {
        return state.paymentsCurrencyAmount
    },
    /**
     * [paymentsTotal description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    paymentsTotal ( state ) {
        return state.paymentsTotal
    },
    /**
     * [paymentsReturned description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    paymentsReturned ( state ) {
        return state.paymentsReturned
    },
    paidTotal ( state ) {
        return state.paidTotal
    },
    /**
     * [paymentsCurrencyJournal description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    paymentsCurrencyJournal ( state ) {
        return state.paymentsCurrencyJournal
    },
    /**
     * [selectedPaymentsBank description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    selectedPaymentsBank ( state ) {
        return state.selectedPaymentsBank
    },
    /**
     * [selectedPaymentsBankType description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    selectedPaymentsBankType ( state ) {
        return state.selectedPaymentsBankType
    },
    /**
     * [paymentsBankRef description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    paymentsBankRef ( state ) {
        return state.paymentsBankRef
    },
    /**
     * [paymentsBankDateMaturity description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    paymentsBankDateMaturity ( state ) {
        return state.paymentsBankDateMaturity
    },
    /**
     * [paymentsBankNumberCta description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    paymentsBankNumberCta ( state ) {
        return state.paymentsBankNumberCta
    },
    /**
     * [paymentsBankNameHolder description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    paymentsBankNameHolder ( state ) {
        return state.paymentsBankNameHolder
    }
}

const mutations = {
    /**
     * [paymentsJournals description]
     * @type {[type]}
     */
    [SET_PAYMENTS_JOURNALS] ( state, payload ){
        state.paymentsJournals = payload
    },
    /**
     * [paymentsSelectedJournal description]
     * @type {[type]}
     */
    [SELECTED_PAYMENTS_JOURNALS] ( state, payload ) {
        state.paymentsSelectedJournal =  payload
    },
    /**
     * [paymentsMoveLines description]
     * @type {Array}
     */
    [SET_ADD_PAYMENTS_MOVE_LINES] (state, payload) {
        state.paymentsMoveLines = [payload, ...state.paymentsMoveLines]
    },
    /**
     * [actions description]
     * @type {Object}
     */
    [SET_REMOVE_PAYMENTS_MOVE_LINES] (state, payload) {
        if (payload.mode === 'full') {
            payload.moveLines.forEach(moves => {
                // Remove Payments
                let movesPaymentsIndex = state.paymentsMoveLines.findIndex(item => item.id === moves.id)
                state.paymentsMoveLines.splice(movesPaymentsIndex)
            })
        } else {
            // Remove Payments
            let movesPaymentsIndex = state.paymentsMoveLines.findIndex(item => item.id === payload.moveLines.id)
            state.paymentsMoveLines.splice(movesPaymentsIndex, 1)
        }
    },
    /**
     * [actions description]
     * @type {Object}
     */
    [CALCULATE_CURRENCY_AMOUNT] ( state, payload ) {
        let currency = payload.currency
        let paymentsMoveLines = payload.paymentsMoveLines
        let paymentsCurrencyAmount = []

        currency.forEach(item => {
            let amount = 0
            paymentsMoveLines.forEach( currency => {
                let currencyMoveLine = currency.currencyAmount.find(move => move.id === item.id)
                amount = amount + currencyMoveLine.amountCurencyResidual
            })
            paymentsCurrencyAmount.push({
                id: item.id,
                symbolCurrency: item.symbol,
                amount: amount,
                symbol: ' ',
                position: 'before',
                thousandsSeparator: item.thousandsSeparator,
                decimalSeparator: item.decimalSeparator,
                decimalPlaces: item.decimalPlaces,
                rateSilent: item.rateSilent
            })
        })
        state.paymentsCurrencyAmount = paymentsCurrencyAmount
    },
    /**
     * [actions description]
     * @type {Object}
     */
    [CALCULATE_PAYMENTS_TOTAL] ( state, payload){
        let currencyJournal = payload.paymentsCurrencyAmount.find(item => item.id ===payload.currency.id)
        let total = 0
        if (currencyJournal)
            total = currencyJournal.amount
        state.paymentsTotal = total
    },
    /**
     * [paidTotal description]
     * @type {[type]}
     */
    [SET_PAID_TOTAL] (state, payload) {
        state.paidTotal = payload
    },
    /**
     * [paymentsCurrencyJournal description]
     * @type {[type]}
     */
    [SET_PAYMENTS_CURRENCY_JOURNAL] ( state, payload ){
        state.paymentsCurrencyJournal = payload
    },
    /**
     * [selectedPaymentsBank description]
     * @type {[type]}
     */
    [SELECTED_PAYMENTS_PURCHASES_BANK] (state, payload){
        state.selectedPaymentsBank = payload
    },
    /**
     * [selectedPaymentsBankType description]
     * @type {[type]}
     */
    [SELECTED_PAYMENTS_PURCHASES_BANK_TYPE] (state, payload){
        state.selectedPaymentsBankType = payload
    },
    /**
     * [paymentsBankRef description]
     * @type {[type]}
     */
    [SET_PAYMENTS_PURCHASES_BANK_REF] (state, payload){
        state.paymentsBankRef = payload
    },
    /**
     * [paymentsBankDateMaturity description]
     * @type {[type]}
     */
    [SET_PAYMENTS_PURCHASES_BANK_DATE_MATURITY] (state, payload){
        state.paymentsBankDateMaturity = payload
    },
    /**
     * [paymentsBankNumberCta description]
     * @type {[type]}
     */
    [SET_PAYMENTS_PURCHASES_BANK_NUMBER_CTA] (state, payload){
        state.paymentsBankNumberCta = payload
    },
    /**
     * [paymentsBankNameHolder description]
     * @type {[type]}
     */
    [SET_PAYMENTS_PURCHASES_BANK_NAME_HOLDER] (state, payload){
        state.paymentsBankNameHolder = payload
    }
}

const actions = {
    /**
     * [INIT_PAYMENTS_JOURNALS]
     */
    [INIT_PAYMENTS_JOURNALS] ({ commit }, payload ) {
        commit(SET_PAYMENTS_JOURNALS, payload)
    },
    /**
     * [SELECT_PAYMENTS_JOURNALS]
     */
    [SELECT_PAYMENTS_JOURNALS] ({ commit, getters }, payload ) {
        commit(SELECTED_PAYMENTS_JOURNALS, payload)

        let currency = []
        if (payload.currency.id){
            currency = payload.currency
        } else {
            currency = getters.currencyCompany
        }
        commit(CALCULATE_PAYMENTS_TOTAL, {
            paymentsCurrencyAmount: getters.paymentsCurrencyAmount,
            currency: currency
        })

        commit(SET_PAYMENTS_CURRENCY_JOURNAL, currency)
    },
    /**
     * [paymentsCurrencyAmount description]
     * @type {Array}
     */
    [RESET_SELECTED_JOURNAL_PAYMENTS] ({ commit }) {
        commit(SELECTED_PAYMENTS_JOURNALS, [])
        commit(CALCULATE_PAYMENTS_TOTAL, {
            paymentsCurrencyAmount: [],
            currency: []
        })
        commit(SET_PAYMENTS_CURRENCY_JOURNAL, [])
    },
    /**
     * [ADD_PAYMENTS_MOVE_LINES]
     */
    [ADD_PAYMENTS_MOVE_LINES] ({ commit, getters, dispatch }, payload ) {
        commit(SET_ADD_PAYMENTS_MOVE_LINES, payload)
        commit(CALCULATE_CURRENCY_AMOUNT, {
            paymentsMoveLines: getters.paymentsMoveLines,
            currency: getters.currency
        })
        dispatch(RESET_SELECTED_JOURNAL_PAYMENTS, [])
    },
    /**
     * [REMOVE_PAYMENTS_MOVE_LINES]
     */
    [REMOVE_PAYMENTS_MOVE_LINES] ({ commit, getters, dispatch }, payload ) {
        commit(SET_REMOVE_PAYMENTS_MOVE_LINES, payload)
        commit(CALCULATE_CURRENCY_AMOUNT, {
            paymentsMoveLines: getters.paymentsMoveLines,
            currency: getters.currency
        })
        dispatch(RESET_SELECTED_JOURNAL_PAYMENTS, [])

    },
    /**
     * [CHANGE_INITIAL_PAID]
     */
    [CHANGE_INITIAL_PAID] ({ commit },payload) {
        commit(SET_PAID_TOTAL, payload)
    },
    /**
     * [RESET_SUPPLIER_PAYMENTS]
     */
    [RESET_SUPPLIER_PAYMENTS] ({ commit, getters }) {
        commit(SET_PAYMENTS_JOURNALS, [])
        commit(SELECTED_PAYMENTS_JOURNALS, [])
        commit(SET_REMOVE_PAYMENTS_MOVE_LINES, {
            mode: 'full',
            moveLines: getters.paymentsMoveLines
        })
        commit(CALCULATE_CURRENCY_AMOUNT, {
            currency: [],
            paymentsMoveLines: []
        })
        commit(SET_PAYMENTS_CURRENCY_JOURNAL, [])
        commit(CALCULATE_PAYMENTS_TOTAL, {
            paymentsCurrencyAmount: [],
            currency: []
        })
        commit(SET_PAID_TOTAL , 0)
    },
    /**
     * [SELECT_PAYMENTS_PURCHASES_BANK]
     */
    [SELECT_PAYMENTS_PURCHASES_BANK] ({ commit }, payload ){
        commit(SELECTED_PAYMENTS_PURCHASES_BANK, payload)
    },
    /**
     * [SELECT_PAYMENTS_PURCHASES_BANK_TYPE]
     */
    [SELECT_PAYMENTS_PURCHASES_BANK_TYPE] ({ commit }, payload ){
        commit(SELECTED_PAYMENTS_PURCHASES_BANK_TYPE, payload)
    },
    /**
     * [CHANGE_PAYMENTS_PURCHASES_BANK_REF]
     */
    [CHANGE_PAYMENTS_PURCHASES_BANK_REF] ({ commit }, payload ){
        commit(SET_PAYMENTS_PURCHASES_BANK_REF, payload)
    },
    /**
     * [CHANGE_PAYMENTS_PURCHASES_BANK_DATE_MATURITY]
     */
    [CHANGE_PAYMENTS_PURCHASES_BANK_DATE_MATURITY] ({ commit }, payload ){
        commit(SET_PAYMENTS_PURCHASES_BANK_DATE_MATURITY, payload)
    },
    /**
     * [CHANGE_PAYMENTS_PURCHASES_BANK_NUMBER_CTA]
     */
    [CHANGE_PAYMENTS_PURCHASES_BANK_NUMBER_CTA] ({ commit }, payload ){
        commit(SET_PAYMENTS_PURCHASES_BANK_NUMBER_CTA, payload)
    },
    /**
     * [CHANGE_PAYMENTS_PURCHASES_BANK_NAME_HOLDER]
     */
    [CHANGE_PAYMENTS_PURCHASES_BANK_NAME_HOLDER] ({ commit }, payload ){
        commit(SET_PAYMENTS_PURCHASES_BANK_NAME_HOLDER, payload)
    },
    /**
     * [RESET_SUPPLIER_PAYMENTS_BANK]
     */
    [RESET_SUPPLIER_PAYMENTS_BANK] ({ commit, dispatch }, payload) {
        commit(SELECTED_PAYMENTS_PURCHASES_BANK, null)
        commit(SELECTED_PAYMENTS_PURCHASES_BANK_TYPE, null)
        commit(SET_PAYMENTS_PURCHASES_BANK_REF, '')
        commit(SET_PAYMENTS_PURCHASES_BANK_DATE_MATURITY,  '')
        commit(SET_PAYMENTS_PURCHASES_BANK_NUMBER_CTA, '')
        commit(SET_PAYMENTS_PURCHASES_BANK_NAME_HOLDER, '')

        dispatch(RESET_SELECTED_JOURNAL_PAYMENTS)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}
